{
open Bibtex_p

exception Eof

let norm_string : string -> string =
  fun s ->
    let r = ref 0 in
    let w = ref 0 in
    let l = String.length s in
    while !r < l do
      let c = s.[!r] in
      if c = '\\'
      then begin
	incr r;
	match s.[!r] with
	| '"' -> s.[!w] <- '"'
	| '\\' -> s.[!w] <- '\\'
	| c' -> s.[!w] <- '\\'; incr w; s.[!w] <- c' end
      else if c = '\n' or c = '\t'
      then s.[!w] <- ' '
      else s.[!w] <- c;
      incr r;
      incr w
    done;
    String.sub s 0 !w;;

} 

let white = [' ' '\t' '\n']
let ident_char = ['A'-'Z' 'a'-'z']

rule token = parse
| '@' { Start }
| ',' { Comma }
| '{' { LeftAcc }
| '}' { RightAcc }
| '"' { Quote }
| '=' { Eq }
| white + { White }
| ident_char +
    { Ident(Lexing.lexeme lexbuf) }
| '\\' _ { Others(Lexing.lexeme lexbuf) }
| _ { Others(Lexing.lexeme lexbuf) }
| eof { raise Eof }

